#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>

#define FALSE 0
#define TRUE 1
#define N 4

#define L1 1 /*37*/
#define L2 1 /*17*/
#define L3 1 /*17*/
#define LM 1 /*11*/
/* parametros para el manipulador PUMA con mueca */
#define D1 L1
#define D2 0
#define D3 0
#define D4 0
#define D5 LM
#define A1 0
#define A2 L2
#define A3 L3
#define A4 0
#define A5 0
#define ALFA1 90
#define ALFA2 0
#define ALFA3 0
#define ALFA4 90
#define ALFA5 0

#define PI 3.1415926

double tita1;
double tita2;
double tita3;
double tita4;
double tita5;

double p[4];	/* punto final (centro de la pinza) */
double a[3];	/* direccion de acercamiento */
double s[3];	/* direccion de cierre */
double n[3];
double cm[3];	/* centro de la mueca (x,y,z) */

double matrizT1[N][N];
double matrizT2[N][N];
double matrizT3[N][N];
double matrizT4[N][N];
double matrizT5[N][N];
double matrizF[N][N];
double matrizT[N][N];
double matrizU[N][N];
/****************************** Prototipos *******************************/
void Error(char *s);
void RecogeDatos(void);
void CentroM(void);
void CalculaAngulos(double x, double y, double z);
void CalculaF(void);
void ConstruyeT(void);
void Multiplica(double matriz[N][N], double vector[N], double result[N]);
void MultiplicaM(double matriz1[N][N], double matriz2[N][N], double result[N][N]);
void CalculaMatrices(double matrizT[N][N], double tita, double alfa, double a, double d);
void Visualizar(void);
/***************************************************************************/
void Error(char *s) {

  printf("ERROR, %s", s);
  exit(0);
}

/***************************************************************************
Procedimiento que recoge todos los datos necesarios por teclado.
***************************************************************************/
void RecogeDatos(void) {

  /* punto final */
  printf("Punto final p: \n");
  printf("x: ");
  scanf("%lf", &p[0]);
  printf("y: ");
  scanf("%lf", &p[1]);
  printf("z: ");
  scanf("%lf", &p[2]);
  /* direccion de acercamiento */
  printf("Direccion a: \n");
  printf("x: ");
  scanf("%lf", &a[0]);
  printf("y: ");
  scanf("%lf", &a[1]);
  printf("z: ");
  scanf("%lf", &a[2]);
  /* direccion de cierre */
  printf("Direccion s: \n");
  printf("x: ");
  scanf("%lf", &s[0]);
  printf("y: ");
  scanf("%lf", &s[1]);
  printf("z: ");
  scanf("%lf", &s[2]);
}

/***************************************************************************
Procedimiento que calcula el centro de la mueca.
Cm = p - Lm * a
****************************************************************************/
void CentroM(void) {
double suma;

  /* comprobar que a est normalizada */
  suma = a[0]*a[0] + a[1]*a[1] + a[2]*a[2];
  suma = sqrt(suma);
  a[0] = a[0] / suma;
  a[1] = a[1] / suma;
  a[2] = a[2] / suma;
  /* comprobar que s est normalizada */
  suma = s[0]*s[0] + s[1]*s[1] + s[2]*s[2];
  suma = sqrt(suma);
  s[0] = s[0] / suma;
  s[1] = s[1] / suma;
  s[2] = s[2] / suma;

  cm[0] = p[0] - LM * a[0];
  cm[1] = p[1] - LM * a[1];
  cm[2] = p[2] - LM * a[2];
}

/***************************************************************************
Funcion que dadas las coordenadas x,y,z calcula cual debe ser la posicin
de cada articulacin (en grados) para alcanzar dichas coordenadas. Debido a
que pueden haber varias soluciones, nos quedaremos siempre con la solucin
codo arriba.
****************************************************************************/
void CalculaAngulos(double x, double y, double z) {
double aux;
double aux1;

  /* comprobamos si el punto es inalcanzable */
  if ((x > L1+L2+L3) || (y > L1+L2+L3) || (z > L1+L2+L3))
	Error("Objetivo inalcanzable (1).");

  /* calculamos tita1 */
  if (x == 0)
	if (y == 0)
	  tita1 = 0;
	else
	  tita1 = 90 * PI / 180.0;
  else
	tita1 = atan(y/x);

  /* calculamos tita3 */
  aux1 = pow((z - L1),2);
  aux = x*x + y*y + aux1 - (L2*L2) - (L3*L3);
  aux1 = 2 * L2 * L3;
  if (aux1 != 0)
	aux = aux / aux1;
  else
	 aux = 0;

  if (fabsl(aux) > 1)
	Error("Objetivo inalcanzable. (2)");

  tita3 = -acos(aux); /* - por solucin codo arriba */

  /* calculamos tita2 */
  aux = sqrt(x*x + y*y);
  if (aux != 0)
	aux = (z -L1) / aux;
  else
	 aux = 0;

  aux1 = L2 + L3 * cos(tita3);
  if (aux1 != 0)
	aux1 = (L3 * sin(tita3)) / aux1;
  else
	 aux1 = 0;

  tita2 = (atan(aux) - atan(aux1));

  /* pasamos a grados */
  tita1 = tita1 * 180.0 / PI;
  tita2 = tita2 * 180.0 / PI;
  tita3 = tita3 * 180.0 / PI;

}

/*************************************************************************
Procedimiento que calcula la matriz F = T1 * T2 * T3
Primero debemos calcular las matrices T
**************************************************************************/
void CalculaF(void) {
double aux[N][N];

  /* d1 = l1; a1 = 0; alfa1 = 90 */
  CalculaMatrices(matrizT1, tita1, ALFA1, A1, D1);
  /* d2 = 0; a2 = l2; alfa2 = 0 */
  CalculaMatrices(matrizT2, tita2, ALFA2, A2, D2);
  /* d3 = 0; a3 = l3; alfa3 = 0 */
  CalculaMatrices(matrizT3, tita3, ALFA3, A3, D3);

  MultiplicaM(matrizT2,matrizT3,aux);
  MultiplicaM(matrizT1,aux,matrizF);
}

/*************************************************************************
Procedimiento que construye la matriz T y la matriz U.
Primero debemos calular n como el producto vectorial de de a * s.
La matriz U es la multiplicacion de la matriz F transpuesta con la
matriz T.
**************************************************************************/
void ConstruyeT(void) {
double aux[N][N];
register int i;
register int j;

  /* vector n */
  n[0] = a[1]*s[2] - a[2]*s[1];
  n[1] = a[2]*s[0] - a[0]*s[2];
  n[2] = a[0]*s[1] - a[1]*s[0];

  /* T = (s,n,a,p,
		  0,0,0,1) */
  matrizT[0][0] = s[0]; matrizT[0][1] = n[0]; matrizT[0][2] = a[0]; matrizT[0][3] = p[0];
  matrizT[1][0] = s[1]; matrizT[1][1] = n[1]; matrizT[1][2] = a[1]; matrizT[1][3] = p[1];
  matrizT[2][0] = s[2]; matrizT[2][1] = n[2]; matrizT[2][2] = a[2]; matrizT[2][3] = p[2];
  matrizT[3][0] = matrizT[3][1] = matrizT[3][2] = 0; matrizT[3][3] = 1;

  /* trasponemos la matriz F --> aux */
  for (i = 0; i < N; i++)
	for (j = 0; j < N; j++)
	  aux[j][i] = matrizF[i][j];


  /* obtenemos la matriz U */
  MultiplicaM(aux, matrizT, matrizU);

  /* calculamos tita 4 y tita 5 */
  tita4 = asin(matrizU[0][2]) * 180.0 / PI;
  if (tita4 < 0)
	 tita4 = -acos(matrizU[1][2]) * 180.0 / PI;

  tita5 = asin(matrizU[2][0]) * 180.0 / PI;
  if (tita5 < 0)
	 tita5 = acos(matrizU[2][1]) * 180.0 / PI;

}

/*************************************************************************
Procedimiento que multiplica una matriz de tamao NxN por una de
tamao Nx1 devolviento en result una matriz de Nx1
**************************************************************************/
void Multiplica(double matriz[N][N], double vector[N], double result[N]) {
int i;
int j;

  for (i = 0; i < N; i++){
	 result[i] = 0;
	 for (j = 0; j < N; j++)
		  result[i] = result[i] + matriz[i][j] * vector[j];
  }

}

/*************************************************************************
Procedimiento que multiplica una matriz de tamao NxN por otra de
tamao NxN devolviento en result una matriz de NxN
**************************************************************************/
void MultiplicaM(double matriz1[N][N], double matriz2[N][N], double result[N][N]) {
register int i;
register int j;
register int k;

  for (i = 0; i < N; i++)
	for (j = 0; j < N; j++) {
	  result[i][j] = 0;
	  for (k = 0; k < N; k++)
		  result[i][j] = result[i][j] + matriz1[i][k] * matriz2[k][j];
	}
}

/*************************************************************************
- tita viene en grados y lo tenemos que pasar a radianes
- idem con alfa
**************************************************************************/
void CalculaMatrices(double matrizT[N][N], double tita, double alfa, double a, double d) {
double titaR;		/* tita en radianes */
double alfaR;		/* alfa en radianes */

  /* calculamos los angulos en radianes */
  titaR = tita * PI / 180.0;
  alfaR = alfa * PI / 180.0;

  matrizT[0][0] = cos(titaR);
  matrizT[0][1] = (-1) * sin(titaR) * cos(alfaR);
  matrizT[0][2] = sin(alfaR) * sin(titaR);
  matrizT[0][3] = a * cos(titaR);

  matrizT[1][0] = sin(titaR);
  matrizT[1][1] = cos(alfaR) * cos(titaR);
  matrizT[1][2] = (-1) * sin(alfaR) * cos(titaR);
  matrizT[1][3] = a * sin(titaR);

  matrizT[2][0] = 0;
  matrizT[2][1] = sin(alfaR);
  matrizT[2][2] = cos(alfaR);
  matrizT[2][3] = d;

  matrizT[3][0] = 0;
  matrizT[3][1] = 0;
  matrizT[3][2] = 0;
  matrizT[3][3] = 1;
}

/***************************************************************************/
void Visualizar(void) {

  printf("\nTita 1: %.3lf", tita1);
  printf("\nTita 2: %.3lf", tita2);
  printf("\nTita 3: %.3lf", tita3);
  printf("\nTita 4: %.3lf", tita4);
  printf("\nTita 5: %.3lf", tita5);
}
/***************************************************************************/
int main() {
char c;


  do {
	clrscr();

	RecogeDatos();
	CentroM();		/* centro de la mueca */

	CalculaAngulos(cm[0],cm[1],cm[2]);	/* tita1, tita2, tita3 */

	CalculaF();

	ConstruyeT();

	/* visualizamos resultados */
	Visualizar();

	printf("\n\nOtra vez? (S/N): ");
	c = getch();
  }while ((c == 'S') || (c == 's'));

  return 0;
}
