#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>

#define FALSE 0
#define TRUE 1

#define L1 1 /*37*/
#define L2 1 /*17*/
#define L3 1 /*17*/
#define LM 1 /*11*/

#define PI 3.1415926

double tita1;
double tita2;
double tita3;

double p[3];
double a[3];	/* direccion de acercamiento */
double s[3];	/* direccion de cierre */
double cm[3];	/* centro de la mueca (x,y,z) */
/****************************** Prototipos *******************************/
void Error(char *s);
void RecogeDatos(double *x, double *y, double *z);
void Visualizar(void);
void Calcula_posicion(double x, double y, double z);

/***************************************************************************/
void Error(char *s) {

  printf("ERROR, %s", s);
  exit(0);
}

/***************************************************************************
Funcion que dadas las coordenadas x,y,z calcula cual debe ser la posicin
de cada articulacin (en grados) para alcanzar dichas coordenadas. Debido a
que pueden haber varias soluciones, nos quedaremos siempre con la solucin
codo arriba.
****************************************************************************/
void Calcula_posicion(double x, double y, double z) {
double aux;
double aux1;

  /* comprobamos si el punto es inalcanzable */
  if ((x > L1+L2+L3) || (y > L1+L2+L3) || (z > L1+L2+L3))
	Error("Objetivo inalcanzable (1).");

  /* calculamos tita1 */
  if (x == 0)
	if (y == 0)
	  tita1 = 0;
	else
	  tita1 = 90 * PI / 180.0;
  else
	tita1 = atan(y/x);

  if ((x < 0) && (y > 0))
	tita1 += PI;

   if ((x < 0) && (y < 0))
	tita1 += PI;
   if ((x > 0) && (y < 0))
     tita1 += 2 * PI;

  if ((y == 0) && (x < 0))
	tita1 = PI;

  if ((x == 0) && (y < 0))
	tita1 += PI;

  /* calculamos tita3 */
  aux1 = pow((z - L1),2);
  aux = x*x + y*y + aux1 - (L2*L2) - (L3*L3);
  aux1 = 2 * L2 * L3;
  if (aux1 != 0)
	aux = aux / aux1;
  else
	 aux = 0;

  if (fabsl(aux) > 1)
	Error("Objetivo inalcanzable. (2)");

  tita3 = -acos(aux); /* - por solucin codo arriba */

  /* calculamos tita2 */
  aux = sqrt(x*x + y*y);
  if (aux != 0)
	aux = (z -L1) / aux;

  aux1 = L2 + L3 * cos(tita3);
  if (aux1 != 0)
	aux1 = (L3 * sin(tita3)) / aux1;

  tita2 = (atan(aux) - atan(aux1));

  /* pasamos a grados */
  tita1 = tita1 * 180.0 / PI;
  tita2 = tita2 * 180.0 / PI;
  tita3 = tita3 * 180.0 / PI;

}
/***************************************************************************
Procedimiento que recoge todos los datos necesarios por teclado.
***************************************************************************/
void RecogeDatos(double *x, double *y, double *z) {

  printf("Introduce la posicin x: ");
  scanf("%lf", x);
  printf("Introduce la posicin y: ");
  scanf("%lf", y);
  printf("Introduce la posicin z: ");
  scanf("%lf", z);
}

/***************************************************************************/
void Visualizar(void) {

  printf("\nTita 1: %.3lf", tita1);
  printf("\nTita 2: %.3lf", tita2);
  printf("\nTita 3: %.3lf", tita3);
}
/***************************************************************************/
int main() {
double x;	/* coordenadas */
double y;
double z;
char c;


  do {
	clrscr();

	RecogeDatos(&x,&y,&z);

	Calcula_posicion(x,y,z);

	/* visualizamos resultados */
	Visualizar();

	printf("\n\nOtra vez? (S/N): ");
	c = getch();
  }while ((c == 'S') || (c == 's'));

  return 0;
}
