/* Libreria PPI */
#include <conio.h>
#include <dos.h>		/* C++ */

/* Parmetros */
#define BASE 0x300
#define PUERTOA BASE
#define PUERTOB BASE+1
#define PUERTOC BASE+2
#define PCONTROL BASE+3
#define W 224
#define R 16

/* Prototipos */
void Escribir(unsigned char articulacion, unsigned char dato);
unsigned char Leer(unsigned char articulacion);
void EnviarPuma(int conf1, int conf2, int conf3, int conf4, int conf5);

/*************************************************************************
Esta funcin enva la configuracin binaria dato a la articulacin
pasada como parmetro.
Las articulaciones empiezan en 0
**************************************************************************/
void Escribir(unsigned char articulacion, unsigned char dato) {

  /* Inicializacin de la PIO */
  outp(PCONTROL,128);
  outp(PUERTOC, 1);
  /* Seleccionamos la articulacion que recibe la configuracin */
  outp(PUERTOA, W+articulacion);
  outp(PUERTOB, dato);
  outp(PUERTOC, 0);
  outp(PUERTOC, 1);
}

/*************************************************************************
Funcin que lee de la PPI la configuracin actual de la articulacin
especificada como parmetro
*************************************************************************/
unsigned char Leer(unsigned char articulacion) {
unsigned char dato;

  /* Inicializacin de la PIO */
  outp(PCONTROL,128);
  outp(PUERTOC, 1);
  /* Seleccionamos la articulacin de lectura */
  outp(PUERTOA, W+6);
  outp(PUERTOB, 16 * articulacion);
  outp(PUERTOC, 0);

  outp(PUERTOC, 1);
  outp(PUERTOA, W+7);
  outp(PUERTOB, 0);
  outp(PUERTOC, 0);

  outp(PUERTOC, 1);
  outp(PCONTROL, 130);
  outp(PUERTOA, R+1);
  outp(PUERTOC, 4);
  delay(1000);
  dato = inp(PUERTOB);

  return(dato);
}

/*************************************************************************
Funcin que enva las configuraciones de los argumentos al PUMA
**************************************************************************/
void EnviarPuma(int conf1, int conf2, int conf3, int conf4, int conf5) {

  Escribir(0, conf1);
  Escribir(1, conf2);
  Escribir(2, conf3);
  Escribir(3, conf4);
  Escribir(4, conf5);
}
