#include <stdio.h>
#include <conio.h>
#include <math.h>
#include "ppi.c"	/* implica C++ */
#include <stdlib.h>

/* longitud de los links */
#define L1 37
#define L2 17
#define L3 17
#define LM 11
#define PI 3.1415926
#define N 4		/* tamao matrices */
#define M 5 	/* n de articulaciones */
/* parametros para el manipulador PUMA con mueca */
#define D1 L1
#define D2 0
#define D3 0
#define D4 0
#define D5 LM
#define A1 0
#define A2 L2
#define A3 L3
#define A4 0
#define A5 0
#define ALFA1 90
#define ALFA2 0
#define ALFA3 0
#define ALFA4 90
#define ALFA5 0


char *opcmenu[8]= {"7",
		   "Salir",
		   "Articulacin a calibrar",
		   "Mover articulacin",
		   "Leer configuracin de la articulacin",
		   "Calibrar",
		   "Calibrar mueca",
		   "Visualizar parmetros"};

double tita1;	/* primer ngulo */
double tita2;	/* segundo ngulo */
double tita3;	/* tercer ngulo */
double tita4;	/* tercer ngulo */
double tita5;	/* tercer ngulo */

int calibrar[M]={0,0,0,0,0};	/* 0 FALSE, 1 TRUE */

/* vectores para conf_binaria = a * tita + b */
double a[M];
double b[M];

unsigned char articulacion= M + 1;		/* articulacion actual */

void Pausa(void);
void CalculaMatriz(double matrizT[N][N], double tita, double alfa, double a, double d);
void Recoge_angulos(void);
void Multiplica(double matriz[N][N], double vector[N], double result[N]);
void Visualizar(double o[N], int m);
void Calcula_direcciones(double o4[N], double o5[N], double punto[N]);
void Calcula_parametros(unsigned char art);
void Calcula_parametrosm(void);
unsigned Menu (char *lista[]);
void Opciones(unsigned opcion);

/*************************************************************************/
void Pausa(void) {

  printf("\nPresiona ENTER para continuar...");
  fflush(stdin);
  getch();
}

/*---------------------------------------------------------------------*/
unsigned char Leer2(unsigned char art) {
unsigned char dato;

  printf("Introduce la conf. binaria para la art. %d: ", art);
  scanf("%d", dato);

  return dato;
}

/*************************************************************************
Funcin que calcula los parmetros a y b para la articulacin pasada como
parmetro. Para ello pide los ngulos en los que se ha situado el manipulador
y las configuraciones binarias obtenidas.
Es necesario que el primer ngulo sea 0.
conf1 = a * angulo1 + b
conf2 = a * angulo2 + b
*************************************************************************/
void Calcula_parametros(unsigned char art) {
double angulo1;
double angulo2;
int conf1;
int conf2;

  printf("Introduce el angulo 1: ");
  scanf("%lf", &angulo1);
  printf("Introduce el angulo 2: ");
  scanf("%lf", &angulo2);
  fflush(stdin);
  printf("Introduce la configuracion 1: ");
  scanf("%d", &conf1);
  printf("Introduce la configuracion 2: ");
  scanf("%d", &conf2);

  /* calculamos los parmetros */
  b[art] = (double)conf1;
  a[art] = ((double)conf2 - b[art]) / (double)angulo2;

  calibrar[articulacion] = 1;
}

/*************************************************************************
Funcin que calcula los parmetros a y b para la articulacin pasada como
parmetro. Para ello pide los ngulos en los que se ha situado el manipulador
y las configuraciones binarias obtenidas.
Es necesario que el primer ngulo sea 0.
conf1 = a * angulo1 + b
conf2 = a * angulo2 + b
*************************************************************************/
void Calcula_parametrosm(void) {
double angulo1_1;
double angulo2_1;
double angulo1_2;
double angulo2_2;
int conf4_1;
int conf4_2;
int conf5_1;
int conf5_2;
int suma;
int resta;

  printf("Introduce el angulo 1 para art. 4: ");
  scanf("%lf", &angulo1_1);
  printf("Introduce el angulo 1 para art. 5: ");
  scanf("%lf", &angulo2_1);

  printf("Introduce la configuracion 4: ");
  scanf("%d", &conf4_1);
  printf("Introduce la configuracion 5: ");
  scanf("%d", &conf5_1);

  suma = conf4_1 + conf5_1;
  resta= conf4_1 - conf5_1;

  /* calculamos los parmetros */
 b[3] = suma;
 b[4] = resta;

  printf("Introduce el angulo 2 para art. 4: ");
  scanf("%lf", &angulo1_2);
  printf("Introduce el angulo 2 para art. 5: ");
  scanf("%lf", &angulo2_2);

  printf("Introduce la configuracion 4: ");
  scanf("%d", &conf4_2);
  printf("Introduce la configuracion 5: ");
  scanf("%d", &conf5_2);

  suma = conf4_2 + conf5_2;
  resta= conf4_2 - conf5_2;

  /* calculamos los parmetros */
  a[3] = (suma - b[3]) / angulo1_2;
  a[4] = (resta - b[4]) / angulo2_2;;
}

/*************************************************************************/
void Visualiza_parametros(void) {
register int i;

  for (i = 0; i <= N; i++) {
	printf("\na%d = %.3lf", i, a[i]);
	printf("\nb%d = %.3lf", i, b[i]);
  }
}

/**************************************************************************/
unsigned Menu (char *lista[]) {
unsigned opcion;
unsigned max;
register unsigned i;

  clrscr();
  gotoxy(21, 8);
  if (articulacion > M)
	printf("Ninguna Articulacion");
  else
	printf("Articulacion de trabajo: %d", articulacion);
  max = atoi (lista[0]);
  for (i = 1; i <= max; i++) {
	 gotoxy(21, 9 + i);
	 printf("%d. %s.", i-1, lista[i]);
  }
  gotoxy(21, 11 + max);
  printf("Opcin: ");
  scanf("%d", &opcion);
  return opcion;
}

/*************************************************************************/
void Opciones(unsigned opcion) {
unsigned char dato;

  clrscr();
  if ((articulacion >= M) && (opcion != 0))
	opcion = 1;
  switch(opcion) {
	/* articulacion a calibrar */
	 case 1: printf("Introduce la articulacin a calibrar: ");
			 scanf("%d", &articulacion);
			 if (articulacion > M) {
			   printf("ERROR, articulacin errnea.");
			   Pausa();
			 }
			 else if (calibrar[articulacion]) {
			   printf("ERROR, articulacin ya calibrada");
			   Pausa();
			 }
			 break;
	/* mover articulacion */
	 case 2: printf("Introduce un valor: ");
			 scanf("%d", &dato);
			 Escribir(articulacion,dato);
			 printf("Brazo movindose...");
			 Pausa();
			 break;
	/* leer configuracion */
	 case 3: dato = Leer(articulacion);
			 printf("Configuracin obtenida %d: ", dato);
			 Pausa();
			 break;
	/* calibrar */
	 case 4: Calcula_parametros(articulacion);
			 break;
	 /* calibrar mueca*/
	 case 5: Calcula_parametrosm();
			 break;
	 case 6: Visualiza_parametros();
			 Pausa();
			 break;
	 case 0: break;
	 default: printf("ERROR");
			  Pausa();
			  break;
  }
}
/*************************************************************************/
int main() {
unsigned opc;


  /* calibracin del robot */
  do{
	 opc = Menu(opcmenu);
	 Opciones(opc);
  }while (opc != 0);

  return 0;
}