#include <stdio.h>
#include <conio.h>
#include <math.h>
#include "ppi.c"	/* implica C++ */
#include <stdlib.h>

#define FALSE 0
#define TRUE 1

/* error para conf. binarias */
#define ERROR1 3	/* articulaciones no mueca */
#define ERROR2 5	/* articulaciones mueca */

/* longitud de los links */
#define L1 37
#define L2 17
#define L3 17
#define LM 11
#define PI 3.1415926
#define N 4		/* tamao matrices */
#define M 5		/* n de parametros */
/* parametros para el manipulador PUMA con mueca */
#define D1 L1
#define D2 0
#define D3 0
#define D4 0
#define D5 LM
#define A1 0
#define A2 L2
#define A3 L3
#define A4 0
#define A5 0
#define ALFA1 90
#define ALFA2 0
#define ALFA3 0
#define ALFA4 90
#define ALFA5 0


char *opcmenu[9]= {"8",
			"Salir",
			"Mover articulacin",
			 "Leer configuracin de la articulacin",
			 "Mueca",
			 "Pinza",
			 "Enviar configuracin",
			 "Calibrar mueca",
			 "Ver parametros"};

double tita1;	/* primer ngulo */
double tita2;	/* segundo ngulo */
double tita3;	/* tercer ngulo */
double tita4;	/* tercer ngulo */
double tita5;	/* tercer ngulo */

/* las articulaciones empiezan en 0 */
unsigned articulacion = 0;		/* articulacion actual */
/* vectores para conf_binaria = a * tita + b */
double a[N];
double b[N];

void Pausa(void);
unsigned Menu (char *lista[]);
void Opciones(unsigned opcion);
void Mueve_articulacion(void);
void Mueve_m(void);
void Calcula_parametrosm(void);
void Visualiza_parametros(void);
unsigned char Angulo2Binario(double angulo);

/*************************************************************************/
void Pausa(void) {

	printf("\nPresiona ENTER para continuar...");
	getch();
}

/*************************************************************************
Funcin que calcula los parmetros a y b para la articulacin pasada como
parmetro. Para ello pide los ngulos en los que se ha situado el manipulador
y las configuraciones binarias obtenidas.
Es necesario que el primer ngulo sea 0.
conf1 = a * angulo1 + b
conf2 = a * angulo2 + b
*************************************************************************/
void Calcula_parametrosm(void) {
int act3;	/* configuracion binaria del actuador 3*/
int act4;	/* configuracion binaria del acuador 4 */
double aux;

  /* creo que deberia ser elevacion 0 */
  printf("Introduce las conf. binarias para elevacion = 90, giro = 0:\n");
  printf("Elevacion: ");
  scanf("%d", &act3);
  printf("Giro: ");
  scanf("%d", &act4);

  aux = (-2) * act3 - 2 * act4 + 4 * act3 + 4 * act4;
  b[3] = aux / 2;

  printf("Introduce las conf. binarias para elevacion = 45, giro = 0:\n ");
  printf("Elevacion: ");
  scanf("%d", &act3);
  printf("Giro: ");
  scanf("%d", &act4);

  aux = 2 * act3 + 2 * act4 - 2 * b[3];
  a[3] = aux / 90;
  aux = 2 * act3 - 45 * a[3] - b[3];
  b[4] = aux;

  /* elevacion = 0? */
  printf("Introduce las conf. binarias para elevacion = 90, giro = 90\n: ");
  printf("Elevacion: ");
  scanf("%d", &act3);
  printf("Giro: ");
  scanf("%d", &act4);

  aux = 2 * act3 - 90 * a[3] - b[3] - b[4];
  a[4] = aux / 90;
}

/*************************************************************************/
void Visualiza_parametros(void) {
register int i;

  for (i = 0; i <= N; i++) {
	printf("\na%d = %.3lf", i, a[i]);
	printf("\nb%d = %.3lf", i, b[i]);
  }
}

/**************************************************************************
Funcion que devuelve la configuracion binaria correspondiente al angulo
pasado como parametro teneniendo en cuenta la articulacion actual.
**************************************************************************/
unsigned char Angulo2Binario(double angulo) {
unsigned char dato;
double aux;

  aux = (double) a[articulacion] * angulo + b[articulacion];
  if ((aux > 255) || (aux < 0)) {
	 printf("Esta articulacin no acepta el angulo %d. (%d)", angulo, aux);
	 printf("\nDevolviendo 100");
	 dato = 0;
	 Pausa();
	 /*exit(0);*/
  }
  else
	 dato = (unsigned char) aux;

  return dato;
}

/**************************************************************************/
/* Procedimiento que mueve una articulacion */
void Mueve_articulacion(void) {
double angulo;
unsigned char dato;
char c;

  do {
	printf("Introduce la articulacin a mover: ");
	scanf("%d", &articulacion);
	if (articulacion > M) {
	  printf("ERROR, articulacin errnea.");
	  Pausa();
	}
	printf("Introduce un ngulo: ");
	scanf("%lf", &angulo);
	dato = Angulo2Binario(angulo);
	/* comprobar que no se sale la conf. binaria de 255 ni de 0
	Comprobar en Angulo2Binario */
	Escribir(articulacion,dato);
	printf("\nBrazo movindose...");
	delay(1000);
	while ((dato < (Leer(articulacion) - ERROR1)) && (dato > (Leer(articulacion) + ERROR1)))
	  delay(1000);
	Pausa();

	printf("\n\nMover otra articulacin? (S/N): ");
	c = getch();
	}while ((c == 'S') || (c == 's'));
}
/**************************************************************************/
/* Procedimiento que mueve la mueca */
void Mueve_m(void) {
double angulo1;
double angulo2;
double aux;
double suma;
double resta;
unsigned char dato;

  printf("Introduce el ngulo de elevacin: ");
  scanf("%lf", &angulo1);
  printf("Introduce el ngulo de giro: ");
  scanf("%lf", &angulo2);
  suma = a[3] * angulo1 + b[3];
  resta = a[4] * angulo2 + b[4];
  aux = (suma + resta)/2 ;
  dato = (unsigned char)aux;
  if ((aux > 255) || (aux < 0)) {
	printf("\nERROR, la conf. binaria para elevacion es %f", aux);
	printf("\Devolviendo 100");
	dato = (unsigned char)100;
	Pausa();
  }
  Escribir(3,dato);
  delay(1000);
  while ((dato < (Leer(3) - ERROR2)) || (dato > (Leer(3) + ERROR2)))
	delay(1000);

  aux = fabsl((suma - resta)/2);
  dato = (unsigned char)aux;
  if ((aux > 255) || (aux < 0)) {
	printf("\nERROR, la conf. binaria para el giro es %f", aux);
	printf("\Devolviendo 100");
	dato = (unsigned char)100;
	Pausa();
  }
  Escribir(4,dato);
  delay(1000);
  while ((dato < (Leer(4) - ERROR2)) || (dato > (Leer(4) + ERROR2)))
	delay(1000);
  Pausa();
}

/**************************************************************************/
unsigned Menu (char *lista[]) {
unsigned opcion;
unsigned max;
register unsigned i;

  clrscr();
  gotoxy(21, 8);
  if (articulacion > M)
	printf("Ninguna Articulacion");
  else
	printf("Articulacion de trabajo: %d", articulacion);
  max = atoi (lista[0]);
  for (i = 1; i <= max; i++) {
	 gotoxy(21, 9 + i);
	 printf("%d. %s.", i-1, lista[i]);
	}
	gotoxy(21, 11 + max);
	printf("Opcin: ");
	scanf("%d", &opcion);
	return opcion;
}

/*************************************************************************/
void Opciones(unsigned opcion) {
unsigned char dato;

  clrscr();
  switch(opcion) {
	/* mover articulacion */
	 case 1: Mueve_articulacion();
			  break;
	/* leer configuracion */
	 case 2: dato = Leer(articulacion);
			 printf("Configuracin obtenida %d: ", dato);
			 Pausa();
			 break;
	/* mueca  */
	 case 3: Mueve_m();
			 break;
	 /* pinza */
	 case 4: printf("APERTURA DE LA PINZA\n");
			 printf("0-abierta, 100-cerrado parcial, 255-cerrado completo: ");
			 scanf("%d", &dato);
			 Escribir(5,dato);
			 Pausa();
			 break;
	 /* enviar configuracion */
	 case 5: printf("Introduce un valor: ");
			 scanf("%d", &dato);
			 Escribir(articulacion,dato);
			 printf("Brazo movindose...");
			 Pausa();
			 break;
	 /* calibrar mueca */
	 case 6: Calcula_parametrosm();
			 break;
	 /* ver parametros */
	 case 7: Visualiza_parametros();
			 Pausa();
			 break;
	 case 0: break;
	 default: printf("ERROR");
			  Pausa();
			  break;
  }
}
/*************************************************************************/
int main() {
unsigned opc;

  /* inicializacin de parmetros */
	a[0] = 1.278; b[0] = 15; a[1] = 1.5; b[1] = 20; a[2] = 1; b[2] = 125;
	/* mueca */
	a[3] = 0.88; b[3] = 103; a[4] = -0.866666; b[4] = 95;

	/* manipulacion del robot */
  do{
	 opc = Menu(opcmenu);
	 Opciones(opc);
  }while (opc != 0);

  return 0;
}