#include <stdio.h>
#include <conio.h>
#include <math.h>
#include "ppi.c"	/* implica C++ */
#include <stdlib.h>

#define FALSE 0
#define TRUE 1

/* error para conf. binarias */
#define ERROR1 3	/* articulaciones no mueca */
#define ERROR2 5	/* articulaciones mueca */

/* longitud de los links */
#define L1 37
#define L2 17
#define L3 17
#define LM 11
#define PI 3.1415926
#define N 4		/* tamao matrices */
#define M 5		/* n de parametros */
/* parametros para el manipulador PUMA con mueca */
#define D1 L1
#define D2 0
#define D3 0
#define D4 0
#define D5 LM
#define A1 0
#define A2 L2
#define A3 L3
#define A4 0
#define A5 0
#define ALFA1 90
#define ALFA2 0
#define ALFA3 0
#define ALFA4 90
#define ALFA5 0

char *opcmenu[12]= {"11",
			"Salir",
			"Mover articulacin",
			 "Leer configuracin de la articulacin",
			 "Mueca",
			 "Pinza",
			 "Enviar configuracin",
			 "Calibrar mueca",
			 "Ver parametros",
			 "Mover PUMA",
			 "Cinemtica inversa",
			 "TODO"};

double t1;	/* primer ngulo */
double t2;	/* segundo ngulo */
double t3;	/* tercer ngulo */
double t4;	/* tercer ngulo */
double t5;	/* tercer ngulo */

double p[3];	/* punto final (centro de la pinza) */
double a[3];	/* direccion de acercamiento */
double s[3];	/* direccion de cierre */
double n[3];
double cm[3];	/* centro de la mueca (x,y,z) */

double matrizT1[N][N];
double matrizT2[N][N];
double matrizT3[N][N];
double matrizT4[N][N];
double matrizT5[N][N];
double matrizF[N][N];
double matrizT[N][N];
double matrizU[N][N];

/* las articulaciones empiezan en 0 */
unsigned articulacion = 0;		/* articulacion actual */
/* vectores para conf_binaria = a * tita + b */
double pa[M]; 	/* parametros a */
double pb[M];   /* parametros b */

void Pausa(void);
unsigned Menu (char *lista[]);
void Opciones(unsigned opcion);
void Mueve_articulacion(void);
void Mueve_m(void);
void Calcula_parametrosm(void);
void Visualiza_parametros(void);
unsigned char Angulo2Binario(double angulo);
void Mover(void);
void Mover2(double tita1, double tita2, double tita3, double tita4, double tita5);
/* prototipos cinematica inversa */
void RecogeDatos(void);
void CentroM(void);
int CalculaAngulos(double x, double y, double z);
void CalculaF(void);
void ConstruyeT(void);
void Multiplica(double matriz[N][N], double vector[N], double result[N]);
void MultiplicaM(double matriz1[N][N], double matriz2[N][N], double result[N][N]);
void CalculaMatrices(double matrizT[N][N], double tita, double alfa, double a, double d);
void Visualizar(void);
void Inversa();
void Principal();

/*************************************************************************/
void Pausa(void) {

	printf("\nPresiona ENTER para continuar...");
	getch();
}

/*************************************************************************
Funcin que calcula los parmetros a y b para la articulacin pasada como
parmetro. Para ello pide los ngulos en los que se ha situado el manipulador
y las configuraciones binarias obtenidas.
Es necesario que el primer ngulo sea 0.
conf1 = a * angulo1 + b
conf2 = a * angulo2 + b
*************************************************************************/
void Calcula_parametrosm(void) {
int act3_0;	/* configuracion binaria del actuador 3 config 0*/
int act4_0;	/* configuracion binaria del acuador 4 config 0*/
int act3_1;	/* configuracion binaria del actuador 3 config 1*/
int act4_1;	/* configuracion binaria del acuador 4 config 1*/
int act3_2;	/* configuracion binaria del actuador 3 config 2*/
int act4_2;	/* configuracion binaria del acuador 4 config 2*/

double aux;

  /* creo que deberia ser elevacion 0 */
  printf("Introduce las conf. binarias para elevacion = 90, giro = 0:\n");
  printf("Articulacion 3: ");
  scanf("%d", &act3_0);
  printf("Articulacion 4: ");
	scanf("%d", &act4_0);



  printf("Introduce las conf. binarias para elevacion = 45, giro = 0:\n");
  printf("Articulacion 3: ");
  scanf("%d", &act3_1);
  printf("Articulacion 4: ");
  scanf("%d", &act4_1);

	/* elevacion = 0? */
  printf("Introduce las conf. binarias para elevacion = 90, giro = 90:\n");
	printf("Articulacion 3: ");
  scanf("%d", &act3_2);
  printf("Articulacion 4: ");
  scanf("%d", &act4_2);

  /* calculamos lo parametros */
  aux = (-2) * act3_0 - 2 * act4_0 + 4 * act3_1 + 4 * act4_1;
  pb[3] = aux / 2;

  aux = 2 * act3_1 + 2 * act4_1 - 2 * pb[3];
  pa[3] = aux / 90;
  aux = 2 * act3_1 - 45 * pa[3] - pb[3];
  pb[4] = aux;

  aux = 2 * act3_2 - 90 * pa[3] - pb[3] - pb[4];
  pa[4] = aux / 90;
}

/*************************************************************************/
void Visualiza_parametros(void) {
register int i;

  for (i = 0; i <= N; i++) {
	printf("\na%d = %.3lf", i, pa[i]);
	printf("\nb%d = %.3lf", i, pb[i]);
  }
}

/**************************************************************************
Funcion que devuelve la configuracion binaria correspondiente al angulo
pasado como parametro teneniendo en cuenta la articulacion actual.
**************************************************************************/
unsigned char Angulo2Binario(double angulo) {
unsigned char dato;
double aux;

	aux = (double) pa[articulacion] * angulo + pb[articulacion];
	if ((aux > 255) || (aux < 0)) {
	 printf("Esta articulacin no acepta el angulo %f. (%d)", angulo, aux);
	 printf("\nDevolviendo 100");
	 dato = 0;
	 Pausa();
	 /*exit(0);*/
	}
	else
	 dato = (unsigned char) aux;

	return dato;
}

/**************************************************************************/
/* Procedimiento que mueve una articulacion */
void Mueve_articulacion(void) {
double angulo;
unsigned char dato;
char c;

	do {
	printf("Introduce la articulacin a mover: ");
	scanf("%d", &articulacion);
	if (articulacion > M) {
		printf("ERROR, articulacin errnea.");
		Pausa();
	}
	printf("Introduce un ngulo: ");
	scanf("%lf", &angulo);
	dato = Angulo2Binario(angulo);
	/* comprobar que no se sale la conf. binaria de 255 ni de 0
	Comprobar en Angulo2Binario */
	Escribir(articulacion,dato);
	printf("\nBrazo movindose...");
	delay(1000);
	while ((dato < (Leer(articulacion) - ERROR1)) && (dato > (Leer(articulacion) + ERROR1)))
		delay(1000);
	Pausa();

	printf("\n\nMover otra articulacin? (S/N): ");
	c = getch();
	}while ((c == 'S') || (c == 's'));
}
/**************************************************************************/
/* Procedimiento que mueve la mueca */
void Mueve_m(void) {
double angulo1;
double angulo2;
double aux;
double suma;
double resta;
unsigned char dato;

  printf("Introduce el ngulo de elevacin: ");
  scanf("%lf", &angulo1);
  printf("Introduce el ngulo de giro: ");
  scanf("%lf", &angulo2);
  suma = pa[3] * angulo1 + pb[3];
  resta = pa[4] * angulo2 + pb[4];
  aux = (suma + resta) /2;
  dato = (unsigned char)aux;
  if ((aux > 255) || (aux < 0)) {
	printf("\nERROR, la conf. binaria para elevacion es %.3lf", aux);
	printf("\Devolviendo 100");
	dato = (unsigned char)100;
	Pausa();
  }
  Escribir(3,dato);
	/*delay(1000);
	while ((dato < (Leer(3) - ERROR2)) || (dato > (Leer(3) + ERROR2)))
	  delay(1000);*/

  aux = fabsl((suma - resta)/2);
  dato = (unsigned char)aux;
  if ((aux > 255) || (aux < 0)) {
	printf("\nERROR, la conf. binaria para el giro es %.3lf", aux);
	printf("\Devolviendo 100");
	dato = (unsigned char)100;
	Pausa();
  }
  Escribir(4,dato);
	/*delay(1000);
	while ((dato < (Leer(4) - ERROR2)) || (dato > (Leer(4) + ERROR2)))
	  delay(1000); */
  Pausa();
}

/**************************************************************************/
void Mover(void) {
unsigned char conf1,
	conf2,
	conf3,
	conf4,
	conf5,
	conf6;
double tita1,
	tita2,
	tita3,
	tita4,
	tita5,
	tita6;
char c;
double aux;
double suma;
double resta;

  do {
	printf("\nArticulacion 1: ");
	scanf("%lf", &tita1);
	articulacion = 0;
	conf1 = Angulo2Binario(tita1);

	printf("Articulacion 2: ");
	scanf("%lf", &tita2);
	articulacion = 1;
	conf2 = Angulo2Binario(tita2);

	printf("Articulacion 3: ");
	scanf("%lf", &tita3);
	articulacion = 2;
	conf3 = Angulo2Binario(tita3);

	printf("Articulacion 4: ");
	scanf("%lf", &tita4);
	printf("Articulacion 5: ");
	scanf("%lf", &tita5);

	suma = pa[3] * tita4 + pb[3];
	resta = pa[4] * tita5 + pb[4];
	aux = (suma + resta) /2;
	conf4 = (unsigned char)aux;
	if ((aux > 255) || (aux < 0)) {
	  printf("\nERROR, la conf. binaria para elevacion es %.3lf", aux);
	  printf("\Devolviendo 100");
	  conf4 = (unsigned char)100;
	  Pausa();
	}
	aux = fabsl((suma - resta)/2);
	conf5 = (unsigned char)aux;
	if ((aux > 255) || (aux < 0)) {
	  printf("\nERROR, la conf. binaria para el giro es %.3lf", aux);
	  printf("\Devolviendo 100");
	  conf5 = (unsigned char)100;
	  Pausa();
	}

	EnviarPuma(conf1, conf2, conf3, conf4, conf5);

	printf("APERTURA DE LA PINZA\n");
	printf("0-abierta, 100-cerrado parcial, 255-cerrado completo: ");
	scanf("%d", &conf6);
	Escribir(5,conf6);

	Pausa();

	printf("\n\nOtra vez? (S/N): ");
	c = getch();
  }while ((c == 'S') || (c == 's'));
}

/**************************************************************************/
void Mover2(double tita1, double tita2, double tita3, double tita4, double tita5) {
unsigned char conf1,
	conf2,
	conf3,
	conf4,
	conf5,
	conf6;
double aux;
double suma;
double resta;

	articulacion = 0;
	conf1 = Angulo2Binario(tita1);

	articulacion = 1;
	conf2 = Angulo2Binario(tita2);

	articulacion = 2;
	conf3 = Angulo2Binario(tita3);

	suma = pa[3] * tita4 + pb[3];
	resta = pa[4] * tita5 + pb[4];
	aux = (suma + resta) /2;
	conf4 = (unsigned char)aux;
	if ((aux > 255) || (aux < 0)) {
	printf("\nERROR, la conf. binaria para elevacion es %.3lf", aux);
	printf("\Devolviendo 100");
	conf4 = (unsigned char)100;
	Pausa();
	}
	aux = fabsl((suma - resta)/2);
	conf5 = (unsigned char)aux;
	if ((aux > 255) || (aux < 0)) {
	printf("\nERROR, la conf. binaria para el giro es %.3lf", aux);
	printf("\Devolviendo 100");
	conf5 = (unsigned char)100;
	Pausa();
	}

	EnviarPuma(conf1, conf2, conf3, conf4, conf5);
	while ((conf1 < (Leer(0) - ERROR1)) && (conf1 > (Leer(0) + ERROR1)) ||
				 (conf2 < (Leer(1) - ERROR1)) && (conf2 > (Leer(1) + ERROR1)) ||
				 (conf3 < (Leer(2) - ERROR1)) && (conf3 > (Leer(2) + ERROR1)))
		delay(1000);
}

/**************************************************************************/
/* Funciones cinematica inversa *******************************************/
/**************************************************************************/

/***************************************************************************
Procedimiento que recoge todos los datos necesarios por teclado.
***************************************************************************/
void RecogeDatos(void) {

  /* punto final */
	printf("Punto final p: \n");
  printf("x: ");
  scanf("%lf", &p[0]);
  printf("y: ");
  scanf("%lf", &p[1]);
  printf("z: ");
  scanf("%lf", &p[2]);
  /* direccion de acercamiento */
  printf("Direccion a: \n");
  printf("x: ");
  scanf("%lf", &a[0]);
  printf("y: ");
  scanf("%lf", &a[1]);
  printf("z: ");
  scanf("%lf", &a[2]);
  /* direccion de cierre */
  printf("Direccion s: \n");
  printf("x: ");
  scanf("%lf", &s[0]);
  printf("y: ");
	scanf("%lf", &s[1]);
  printf("z: ");
  scanf("%lf", &s[2]);
}

/***************************************************************************
Procedimiento que calcula el centro de la mueca.
Cm = p - Lm * a
****************************************************************************/
void CentroM(void) {
double suma;

  /* comprobar que a est normalizada */
  suma = a[0]*a[0] + a[1]*a[1] + a[2]*a[2];
  suma = sqrt(suma);
  a[0] = a[0] / suma;
  a[1] = a[1] / suma;
  a[2] = a[2] / suma;
  /* comprobar que s est normalizada */
  suma = s[0]*s[0] + s[1]*s[1] + s[2]*s[2];
	suma = sqrt(suma);
  s[0] = s[0] / suma;
  s[1] = s[1] / suma;
  s[2] = s[2] / suma;

  cm[0] = p[0] - LM * a[0];
  cm[1] = p[1] - LM * a[1];
  cm[2] = p[2] - LM * a[2];
}

/***************************************************************************
Funcion que dadas las coordenadas x,y,z calcula cual debe ser la posicin
de cada articulacin (en grados) para alcanzar dichas coordenadas. Debido a
que pueden haber varias soluciones, nos quedaremos siempre con la solucin
codo arriba.
****************************************************************************/
int CalculaAngulos(double x, double y, double z) {
double aux;
double aux1;

	/* comprobamos si el punto es inalcanzable */
  if ((x > L1+L2+L3) || (y > L1+L2+L3) || (z > L1+L2+L3)) {
	printf("\nObjetivo inalcanzable (1).");
	return FALSE;
  }

  /* calculamos tita1 */
  if (x == 0)
	if (y == 0)
	  t1 = 0;
	else
	  t1 = 90 * PI / 180.0;
  else
	t1 = atan(y/x);

  /* segundo cuadrante */
  if ((x < 0) && (y > 0))
	t1 += PI;
  /* terce cuadrante */
  if ((x < 0) && (y < 0))
	t1 += PI;
  /* cuarto cuadrante */
  if ((x > 0) && (y < 0))
	t1 += 2 * PI;
  /* eje X negativo */
  if ((y == 0) && (x < 0))
	t1 = PI;
  /* eje Y negativo */
  if ((x == 0) && (y < 0))
	t1 += PI;

  /* calculamos tita3 */
  aux1 = pow((z - L1),2);
  aux = x*x + y*y + aux1 - (L2*L2) - (L3*L3);
  aux1 = 2 * L2 * L3;
  if (aux1 != 0)
	aux = aux / aux1;

  if (fabsl(aux) > 1) {
	printf("\nObjetivo inalcanzable. (2)");
	return FALSE;
  }

  t3 = -acos(aux); /* - por solucin codo arriba */

  /* calculamos tita2 */
  aux = sqrt(x*x + y*y);
  if (aux != 0)
	aux = (z -L1) / aux;

  aux1 = L2 + L3 * cos(t3);
  if (aux1 != 0)
	aux1 = (L3 * sin(t3)) / aux1;

  t2 = (atan(aux) - atan(aux1));

  /* pasamos a grados */
  t1 = t1 * 180.0 / PI;
  t2 = t2 * 180.0 / PI;
  t3 = t3 * 180.0 / PI;

  return TRUE;
}

/*************************************************************************
Procedimiento que calcula la matriz F = T1 * T2 * T3
Primero debemos calcular las matrices T
**************************************************************************/
void CalculaF(void) {
double aux[N][N];

  /* d1 = l1; a1 = 0; alfa1 = 90 */
  CalculaMatrices(matrizT1, t1, ALFA1, A1, D1);
  /* d2 = 0; a2 = l2; alfa2 = 0 */
  CalculaMatrices(matrizT2, t2, ALFA2, A2, D2);
  /* d3 = 0; a3 = l3; alfa3 = 0 */
  CalculaMatrices(matrizT3, t3, ALFA3, A3, D3);

  MultiplicaM(matrizT2,matrizT3,aux);
  MultiplicaM(matrizT1,aux,matrizF);
}

/*************************************************************************
Procedimiento que construye la matriz T y la matriz U.
Primero debemos calular n como el producto vectorial de de a * s.
La matriz U es la multiplicacion de la matriz F transpuesta con la
matriz T.
**************************************************************************/
void ConstruyeT(void) {
double aux[N][N];
register int i;
register int j;

  /* vector n */
  n[0] = a[1]*s[2] - a[2]*s[1];
  n[1] = a[2]*s[0] - a[0]*s[2];
  n[2] = a[0]*s[1] - a[1]*s[0];

  /* T = (s,n,a,p,
		  0,0,0,1) */
	matrizT[0][0] = s[0]; matrizT[0][1] = n[0]; matrizT[0][2] = a[0]; matrizT[0][3] = p[0];
  matrizT[1][0] = s[1]; matrizT[1][1] = n[1]; matrizT[1][2] = a[1]; matrizT[1][3] = p[1];
  matrizT[2][0] = s[2]; matrizT[2][1] = n[2]; matrizT[2][2] = a[2]; matrizT[2][3] = p[2];
  matrizT[3][0] = matrizT[3][1] = matrizT[3][2] = 0; matrizT[3][3] = 1;

  /* trasponemos la matriz F --> aux */
  for (i = 0; i < N; i++)
	for (j = 0; j < N; j++)
	  aux[j][i] = matrizF[i][j];


  /* obtenemos la matriz U */
  MultiplicaM(aux, matrizT, matrizU);

  /* calculamos tita 4 y tita 5 */
  t4 = asin(matrizU[0][2]) * 180.0 / PI;
  if (t4 < 0)
	 t4 = -acos(matrizU[1][2]) * 180.0 / PI;

  t5 = asin(matrizU[2][0]) * 180.0 / PI;
	if (t5 < 0)
	 t5 = acos(matrizU[2][1]) * 180.0 / PI;

}

/*************************************************************************
Procedimiento que multiplica una matriz de tamao NxN por una de
tamao Nx1 devolviento en result una matriz de Nx1
**************************************************************************/
void Multiplica(double matriz[N][N], double vector[N], double result[N]) {
int i;
int j;

  for (i = 0; i < N; i++){
	 result[i] = 0;
	 for (j = 0; j < N; j++)
		  result[i] = result[i] + matriz[i][j] * vector[j];
  }

}

/*************************************************************************
Procedimiento que multiplica una matriz de tamao NxN por otra de
tamao NxN devolviento en result una matriz de NxN
**************************************************************************/
void MultiplicaM(double matriz1[N][N], double matriz2[N][N], double result[N][N]) {
register int i;
register int j;
register int k;

  for (i = 0; i < N; i++)
	for (j = 0; j < N; j++) {
	  result[i][j] = 0;
		for (k = 0; k < N; k++)
		  result[i][j] = result[i][j] + matriz1[i][k] * matriz2[k][j];
	}
}

/*************************************************************************
- tita viene en grados y lo tenemos que pasar a radianes
- idem con alfa
**************************************************************************/
void CalculaMatrices(double matrizT[N][N], double tita, double alfa, double a, double d) {
double titaR;		/* tita en radianes */
double alfaR;		/* alfa en radianes */

  /* calculamos los angulos en radianes */
  titaR = tita * PI / 180.0;
  alfaR = alfa * PI / 180.0;

  matrizT[0][0] = cos(titaR);
  matrizT[0][1] = (-1) * sin(titaR) * cos(alfaR);
  matrizT[0][2] = sin(alfaR) * sin(titaR);
	matrizT[0][3] = a * cos(titaR);

  matrizT[1][0] = sin(titaR);
  matrizT[1][1] = cos(alfaR) * cos(titaR);
  matrizT[1][2] = (-1) * sin(alfaR) * cos(titaR);
  matrizT[1][3] = a * sin(titaR);

	matrizT[2][0] = 0;
  matrizT[2][1] = sin(alfaR);
  matrizT[2][2] = cos(alfaR);
  matrizT[2][3] = d;

  matrizT[3][0] = 0;
  matrizT[3][1] = 0;
  matrizT[3][2] = 0;
  matrizT[3][3] = 1;
}

/***************************************************************************/
void Visualizar(void) {

  printf("\nTita 1: %.3lf", t1);
  printf("\nTita 2: %.3lf", t2);
  printf("\nTita 3: %.3lf", t3);
  printf("\nTita 4: %.3lf", t4);
  printf("\nTita 5: %.3lf", t5);
}

/***************************************************************************/
void Inversa(void) {
char c;

  do {
	clrscr();
	RecogeDatos();
	CentroM();		/* centro de la mueca */
	if (CalculaAngulos(cm[0],cm[1],cm[2])) {	/* tita1, tita2, tita3 */
		CalculaF();
		ConstruyeT();
		/* visualizamos resultados */
		Visualizar();
		printf("\n\nEnviar resultados al PUMA? (S/N): ");
		c = getch();
		if ((c == 'S') || (c == 's'))
		  Mover2(t1,t2,t3,t4,t5);
	}

	printf("\nOtra vez? (S/N): ");
	c = getch();
 }while ((c == 'S') || (c == 's'));
}
/**************************************************************************
Procedimiento que recoge un objeto en una posicin determinada y lo lleva
a otra dada.
***************************************************************************/
void Principal(void){
double p_[3];	/* punto final (centro de la pinza) */
double pf[3], af[3], sf[3];	/* datos del punto final */
register int i;
int OK = FALSE;	/* indica si se ha podido llegar al punto intermedio */
char aux;

  clrscr();
  printf("DATOS DE ORIGEN:\n");
  RecogeDatos();
  /* Datos finales */
  printf("\n\nDATOS DE DESTINO:\n");
  printf("Punto final p: \n");
	printf("x: ");
  scanf("%lf", &pf[0]);
  printf("y: ");
  scanf("%lf", &pf[1]);
  printf("z: ");
	scanf("%lf", &pf[2]);
  /* direccion de acercamiento */
  printf("Direccion a: \n");
  printf("x: ");
  scanf("%lf", &af[0]);
  printf("y: ");
  scanf("%lf", &af[1]);
	printf("z: ");
  scanf("%lf", &af[2]);
  /* direccion de cierre */
  printf("Direccion s: \n");
  printf("x: ");
  scanf("%lf", &sf[0]);
  printf("y: ");
  scanf("%lf", &sf[1]);
	printf("z: ");
  scanf("%lf", &sf[2]);

  /* almacenamos los datos del punto inicial ya que de momento tenemos que ir
  a un punto intermedio */
	for (i = 0; i < 3; i++)
		p_[i] = p[i];

	/* calculamos el punto intermedio. Va a estar encima del objeto */
	p[2] += 10;

	CentroM();		/* centro de la mueca */
	if (CalculaAngulos(cm[0],cm[1],cm[2])) {	/* tita1, tita2, tita3 */
	CalculaF();
	ConstruyeT();
	/* nos aseguramos la pinza abierta */
	Escribir(5,5);
	Mover2(t1,t2,t3,t4,t5);
	OK = TRUE;
	/* esperamos hasta que se alcance el punto */
	delay(3000);
  }

  /* llegamos hasta el objeto */
  if (OK) {
	OK = FALSE;
	for (i = 0; i < 3; i++)
		p[i] = p_[i];
	CentroM();		/* centro de la mueca */
	if (CalculaAngulos(cm[0],cm[1],cm[2])) {	/* tita1, tita2, tita3 */
		CalculaF();
		ConstruyeT();
		Mover2(t1,t2,t3,t4,t5);
		delay(3000);
		/* cerramos la pinza */
		Escribir(5,190);
		OK = TRUE;
	}
	}

	delay(3000);
	/* dejamos el objeto */
	if (OK) {
	/* usamos los datos del destino */
	for (i = 0; i < 3; i++) {
		p[i] = pf[i];
		a[i] = af[i];
		s[i] = sf[i];
	}
	CentroM();		/* centro de la mueca */
	if (CalculaAngulos(cm[0],cm[1],cm[2])) {	/* tita1, tita2, tita3 */
		CalculaF();
		ConstruyeT();
	/* elevamos un poco el objeto: 10 grados ms alto la articulacin 1 */
		articulacion = 1;
		aux = Angulo2Binario(t2+10);
		Escribir(1,aux);
		while ((aux < (Leer(1) - ERROR1)) && (aux > (Leer(1) + ERROR1)))
			delay(1000);
		Mover2(t1,(t2+10),t3,t4,t5);
		delay(1000);

		/* bajamos el brazo */
		articulacion = 1;
		aux = Angulo2Binario(t2);
		Escribir(1,aux);
		while ((aux < (Leer(1) - ERROR1)) && (aux > (Leer(1) + ERROR1)))
			delay(1000);
		/* abrimos la pinza */
		Escribir(5,10);
	}
  }

}

/**************************************************************************/
unsigned Menu (char *lista[]) {
unsigned opcion;
unsigned max;
register unsigned i;

  clrscr();
  max = atoi (lista[0]);
  for (i = 1; i <= max; i++) {
   gotoxy(21, 9 + i);
   printf("%d. %s.", i-1, lista[i]);
  }
  gotoxy(21, 11 + max);
  printf("Opcin: ");
  scanf("%d", &opcion);
  return opcion;
}

/*************************************************************************/
void Opciones(unsigned opcion) {
unsigned char dato;
char c;

	clrscr();
	switch(opcion) {
	/* mover articulacion */
	 case 1: Mueve_articulacion();
				break;
	/* leer configuracion */
	case 2: printf("Introduce la articulacin a leer: ");
			scanf("%d", &articulacion);
			if (articulacion > M) {
			  printf("ERROR, articulacin errnea.");
			  Pausa();
			  break;
			}
			dato = Leer(articulacion);
			printf("Configuracin obtenida %d: ", dato);
			Pausa();
			break;
	/* mueca  */
	 case 3: Mueve_m();
			 break;
	 /* pinza */
	 case 4: printf("APERTURA DE LA PINZA\n");
			 printf("0-abierta, 100-cerrado parcial, 255-cerrado completo: ");
			 scanf("%d", &dato);
			 Escribir(5,dato);
			 break;
	 /* enviar configuracion */
	 case 5:do {
			  printf("\nIntroduce articulacion: ");
			  scanf("%d", &articulacion);
			  printf("Introduce un valor: ");
			  scanf("%d", &dato);
			  Escribir(articulacion,dato);
			  printf("\n\nOtra vez? (S/N): ");
				c = getch();
			}while ((c == 'S') || (c == 's'));
			 break;
	 /* calibrar mueca */
	 case 6: Calcula_parametrosm();
			 break;
	 /* ver parametros */
	 case 7: Visualiza_parametros();
			 Pausa();
			 break;
	 /* mover PUMA */
	 case 8: Mover();
			 break;
	 /* Cinematica inversa */
	 case 9: Inversa ();
			 break;
	 case 10: Principal();
			  break;
	 case 0: break;
	 default: printf("ERROR");
				Pausa();
			  break;
  }
}
/*************************************************************************/
int main() {
unsigned opc;

  /* inicializacin de parmetros */
	pa[0] = -1.277; pb[0] = 245; pa[1] = 1.5; pb[1] = 20; pa[2] = 1; pb[2] = 125;
	/* mueca */
	pa[3] = 1.911; pb[3] = 34; pa[4] = 1.711; pb[4] = -120;

	/* manipulacion del robot */
	do{
	 opc = Menu(opcmenu);
	 Opciones(opc);
	}while (opc != 0);

	return 0;
}